      PROGRAM main_optim

      use declare
      use boundedls

      implicit none

      integer     :: i, j, ix, it, ndata
      character*1 :: tdum
      character*10 :: species
      character*20 :: nox,tag
      character*70 :: filew,files,filep,outfile
      real*8      :: factor(6), cstr(6)
      real*8      :: dumy

!------------------------------------------------------------
! Paramteres to be changed by the user
!------------------------------------------------------------

      species="OLE2_OH" !ideal" !c12"
      !species="c12" !ideal" !c12"
      nox="0.1"
      tag="allgas"

! Specify rate constants and factors


! -> factor correction for the partitioning 
      cstr(1)=1e4
      cstr(2)=1e2
      cstr(3)=1e1
      cstr(4)=1e0
      cstr(5)=1e-1
      cstr(6)=1e-3

      !cstr(1)=1e4
      !cstr(2)=1e2
      !cstr(3)=10**(0.5)
      !cstr(4)=10**(-0.5)
      !cstr(5)=10**(-1.5)
      !cstr(6)=1e-2

!factor=(C*/(OM+C*))
      do i=1,nspec
         factor(i) = (cstr(i) / (10.0+cstr(i)))
      end do
      print*,"COEFS: ",factor


! -> for precusor reaction as kp = k*OH

      filew = '../INPUTS_ODE/5days/' // trim(nox) // &
              '_aer.' // trim(species) // '/aer.wmol_vbs.6'
      files = '../INPUTS_ODE/5days/' // trim(nox) // &
              '_aer.' // trim(species) // '/aer.cdis_all.6'
      filep = '../INPUTS_ODE/5days/' // trim(nox) // &
              '_aer.' // trim(species) // '/aer.precursor'
      print*,"files: ",files
      print*,"files: ",filep
      print*,"filew: ",filew


! Modify if needed ------------------------------
      SELECT CASE (species)
      CASE ("ideal")    !8h rate cte for vbs species
            files = 'aer.ideal'
            filep = 'aer.precursor.ideal'
            kp=1.e-11*2.e6
            do i=1,nspec
               k(i)=1.0/(3600*8.0)*factor(i)
            end do
      CASE ("c12")
            kp=1.32*1.e-11*2.e6  !c12h26
            !k(1)=1.0/(3600*9.1)*factor(1)
            !k(2)=1.0/(3600*8.1)*factor(2)
            !k(3)=1.0/(3600*7.0)*factor(3)
            !k(4)=1.0/(3600*7.8)*factor(4)
            !k(5)=1.0/(3600*3.2)*factor(5)
            !k(6)=1.0/(3600*3.1)*factor(6)
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do
      CASE ("C16")
            kp=1.96*1.e-11*2.e6  !c12h26
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do
      CASE ("ALK4")
            !kp=9.13*1.e-17*2.e6  !c12h26
            kp=4.38132*1.e-12*2.e6  !c12h26
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do

      CASE ("c18")
            kp=2.24*1.e-11*2.e6  !C08000
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do
      CASE ("c22")
            kp=2.81*1.e-11*2.e6  !C08000
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do

      CASE ("TOL")
            kp=5.6*1.e-12*2.e6   !tol
            !k(1)=1.0/(3600*7.0)*factor(1)
            !k(2)=1.0/(3600*21.7)*factor(2)
            !k(3)=1.0/(3600*19.9)*factor(3)
            !k(4)=1.0/(3600*2.6)*factor(4)
            !k(5)=1.0/(3600*3.2)*factor(5)
            !k(6)=1.0/(3600*36.6)*factor(6)

            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do

      CASE ("xyl")
            kp=1.43*1.e-11*2.e6   !tol
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do

      CASE ("API_OH")
            kp=5.22*1.e-11*2.e6  !apin
            !k(1)=1.0/(3600*34.0)*factor(1)
            !k(2)=1.0/(3600*19.0)*factor(2)
            !k(3)=1.0/(3600*10.0)*factor(3)
            !k(4)=1.0/(3600*10.0)*factor(4)
            !k(5)=1.0/(3600*5.0)*factor(5)
            !k(6)=1.0/(3600*6.0)*factor(6)
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do
            k(6)=1.0/(3600*1.0)*factor(6)

      CASE ("lim")
            kp=1.64*1.e-10*2.e6  
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do

      CASE ("TERP_OH")
            !kp=5.2*1.e-11*2.e6  !apin
           kp=8.25672E-11*2.e6
            do i=1,nspec
               k(i)=2*1.e-11*2.e6*factor(i)
            end do
            !k(6)=1.0/(3600*0.2)*factor(6)

      CASE ("ISO_OH")
            kp=9.83e-11*2.e6
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do
      CASE ("OLE1_OH")
            kp=4.68e-11*2.e6
            do i=1,nspec
               k(i)=2*1.e-11*2.e6*factor(i)
            end do

      CASE ("OLE2_OH")
            kp=7.06e-11*2.e6 
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
            end do

      CASE DEFAULT
            kp=1.e-11*2.e6
            do i=1,nspec
               k(i)=2.*1.e-11*2.e6*factor(i)
               !k(i)=1.0/(3600*8.0)*factor(i)
            end do
      END SELECT


! -> to get rid of some reactions eg. VB6+OH reactions just set kOH=0.0
      !k(1)=0.0 
      !k(2)=0.0 
      !k(3)=0.0 
      !k(4)=0.0 
      !k(5)=0.0 
      !k(6)=0.0 

      if(trim(tag).eq."static")then
        k(1)=0.0
        k(2)=0.0
        k(3)=0.0
        k(4)=0.0
        k(5)=0.0
        k(6)=0.0
      else if(trim(tag).eq."no56")then
        k(5)=0.0
        k(6)=0.0
      else if(trim(tag).eq."no6")then
        k(6)=0.0
      endif
      print*,"k per sec  ",k


!------------------------------------------------------------
! Read time dependent GECKO concentrations binned into VBS 
! bins (total aerosol + gas concentrations) 
!------------------------------------------------------------


      SELECT CASE (species)

      CASE ("ideal")    ! idealized case
      OPEN(20,file=filep,STATUS='OLD',FORM='FORMATTED')
      READ(20,*)
      do it=1,ntime
         READ(20,40,END=140)time(it),precursor(it)
40       format(2E24.14)
      end do
140   CONTINUE
      CLOSE(20)

      OPEN(30,file=files,STATUS='OLD',FORM='FORMATTED')
      READ(30,*)
      do it=1,ntime
         READ(30,*,END=210)time(it),(ygecko(i,it),i=1,nspec)
110      format(20E24.14)
      end do
210   CONTINUE
      CLOSE(30)


      CASE DEFAULT  !real case: read GECKO files

      OPEN(20,file=filep,STATUS='OLD',FORM='FORMATTED')
      READ(20,*)
      do it=1,ntime
         READ(20,50,END=150)time(it),precursor(it)
50       format(2E13.5)
      end do
150   CONTINUE
      CLOSE(20)

      OPEN(30,file=files,STATUS='OLD',FORM='FORMATTED')
      do it=1,ntime
         READ(30,100,END=200)time(it),(ygecko(i,it),i=1,nspec)
100      format(20E13.5)
         !print*,"initial data ",it,time(it),ygecko(:,it)
      end do
200   CONTINUE
      CLOSE(30)

      OPEN(60,file=filew,STATUS='OLD',FORM='FORMATTED')
      do it=1,ntime
         READ(60,100,END=250)time(it),(wmol(i,it),i=1,nspec)
       !  print*,time(it),(wmol(i,it),i=1,nspec)
      end do
250   CONTINUE
      CLOSE(60)
      END SELECT
      !print*,"tototo"

!------------------------------------------------------------
! Optimisation using SVDFIT 
!
! at time=t1
! dVB1/dt        = k1*alpha1*VOC + (a11-1)k*factor*VB1 + k*factor*a21*VB2 + k*factor*a31*VB3 + k*factor*a41*VB4
! ...
! at time=tn
! dVB1/dt        = k1*alpha1*VOC + (a11-1)k*factor*VB1 + k*factor*a21*VB2 + k*factor*a31*VB3 + k*factor*a41*VB4
! 
! coefficents do not depend on the time
!------------------------------------------------------------
!
! ->  Prepare for optimization
      do i=1,nspec
      do it=1,ntime-1
       deltat=time(it+1)-time(it) 
       dygecko(i,it)=(ygecko(i,it+1)-ygecko(i,it))/deltat
       avggecko(i,it)=(ygecko(i,it+1)+ygecko(i,it))/2.
       xind(it)=float(it)
      end do
      end do

! ->  Precursor
      do it=1,ntime-1
       avgprecursor(it)=(precursor(it+1)+precursor(it))/2.
      end do
      
!wmol
      avgwmol(:)=0.0
      do i=1,nspec
      do it=1,ntime-1
       avgwmol(i)=avgwmol(i)+wmol(i,it)
      end do
       avgwmol(i)=avgwmol(i)/ntime
      end do
     print*,"WMOL ",avgwmol

! ->  Multiply by the rate constant
      do it=1,ntime-1
         kprecursor(it)= kp*avgprecursor(it) !this is precursor
         abvlsx(it,1)=kprecursor(it)
         do i=1,nspec
            kygecko(i,it)= k(i)*avggecko(i,it)  !other VBS species
            abvlsx(it,i+1)=kygecko(i,it)
         end do 
      end do 

      print*,"TAG ",tag
      outfile='FITS/fit6_coef.'//trim(species)//"."//trim(nox)//"."//trim(tag)
   
      OPEN(11,file=outfile,STATUS='NEW',FORM='FORMATTED')

      print*,"RESULTS =====> FITTED COEFS"
      print*,"Outputs given as"
      print*,"a01   a11    a21     a31    a41    a51     a61       "
      print*,"a02   a12    a22     a32    a42    a52     a62       "
      write(11,*),"Outputs given as"
      write(11,*),"VOC   VB1    VB2     VB3    VB4    VB5   VB6    "


      do i=1,nspec
!
      keybvls=0
      do j=1,nparam
       alphal(j)=0.0
       alphau(j)=10000.
       !print*,"alpha ",alphau(j)
       istatebvls(j)=j
      end do
! -> set upper and lower bounds for the coefficeients
      alphal(i+1)=-1.0  
      alphau(i+1)=1.-1.0  !alma
      istatebvls(nparam+1)=0

      do j=1,ntime-1
         bbvls(j)=dygecko(i,j)
         do ix=1,nspec+1
            abvls(j,ix)=abvlsx(j,ix)
         end do
      end do
      !print*,"in ",alphau,keybvls,ntime-1,nparam
      call bvls(keybvls,ntime-1,nparam,abvls,bbvls, &
                alphal,alphau,alpha,istatebvls,loopabvls)

! take out this line if we need to generate ODEs - no this line has to
! stay!!!! 
      alpha(i+1)=alpha(i+1)+1. 

      print*,"coefs for species nb. ", i
      write(*,400) alpha
400   format(8(1x,e10.3))

      write(11,400)alpha

      end do

      dumy=0.0
      write(11,410),dumy,avgwmol
410   format(8(1x,e10.3))

      CLOSE(11)
 
      stop
      END

