      PROGRAM main_optim

      implicit none
      integer, parameter :: ntime=1+9*24*3600/360/10   !Nb GECKO time
      integer, parameter :: ntime2=2*ntime
      integer     :: i, j, ix, it, ndata
      character*1 :: tdum
      character*10 :: species
      character*20 :: nox,tag
      character*70 :: filew,files,filep,outfile
      real*8      :: factor(6), cstr(6)
      real*8      :: dumy
      integer, parameter :: nspec=6        !Nb of VBS species
      integer, parameter :: nparam=7       !Nb of coefs to fit



      real*8, dimension(ntime) :: time   !GECKO time array in sec
      real*8, dimension(ntime2) :: time2   !GECKO time array in sec
      real*8, dimension(nspec,ntime)   :: ygecko   !GECKO concentrations
      real*8, dimension(nspec,ntime2)   :: ygecko2   !GECKO concentrations
      real*8, dimension(nspec,ntime)   :: wmol
      real*8, dimension(nspec,ntime2)   :: wmol2
      real*8, dimension(nspec)         :: avgwmol
      real*8, dimension(ntime)         :: precursor!GECKO concentrations
      real*8, dimension(ntime2)         :: precursor2!GECKO concentrations

      real*8, dimension(nspec,ntime-1)   :: kygecko
      real*8, dimension(ntime-1)   :: kprecursor
      real*8, dimension(nspec,ntime-1) :: dygecko  !Derivatives
      real*8, dimension(nspec,ntime-1) :: avggecko !Average conc over dt
      real*8, dimension(ntime-1)       :: avgprecursor !Average conc
      real*8, dimension(ntime-1)       :: xind,sigm
      real*8, dimension(nparam)   :: w
      real*8, dimension(nparam,nparam)   :: v
      real*8, dimension(ntime-1,nparam)   :: u

! -> for precusor reaction as kp = k*OH


      filew = 'aer.wmol_vbs.6'
      files = 'aer.cdis_all.6'
      filep = 'aer.precursor'
      print*,"files: ",files
      print*,"files: ",filep
      print*,"filew: ",filew

      OPEN(60,file=filew,STATUS='OLD',FORM='FORMATTED')
      do it=1,ntime
         READ(60,100,END=250)time(it),(wmol(i,it),i=1,nspec)
       !  print*,time(it),(wmol(i,it),i=1,nspec)
      end do
250   CONTINUE
      CLOSE(60)

      OPEN(20,file=filep,STATUS='OLD',FORM='FORMATTED')
      READ(20,*)
      do it=1,ntime
         READ(20,50,END=150)time(it),precursor(it)
50       format(2E13.5)
      end do
150   CONTINUE
      CLOSE(20)

      OPEN(30,file=files,STATUS='OLD',FORM='FORMATTED')
      do it=1,ntime
         READ(30,100,END=200)time(it),(ygecko(i,it),i=1,nspec)
100      format(20E13.5)
         !print*,"initial data ",it,time(it),ygecko(:,it)
      end do
200   CONTINUE
      CLOSE(30)

      precursor2(:)=0.0
      time2(:)=0.0
      ygecko2(:,:)=0.0
      wmol2(:,:)=0.0
      do it=1,ntime2,2
         precursor2(it)=precursor((it+1)/2)
         time2(it)=time((it+1)/2)
      do i=1,nspec
         ygecko2(i,it)=ygecko(i,(it+1)/2)
         wmol2(i,it)=wmol(i,(it+1)/2)
      enddo
      enddo
      do it=2,ntime2-1,2
         precursor2(it)=(precursor(it/2)+precursor((it+1)/2+1))/2.
         time2(it)=(time(it/2)+time((it+1)/2+1))/2.
      do i=1,nspec
         ygecko2(i,it)=(ygecko(i,it/2)+ygecko(i,(it+1)/2+1))/2.
         wmol2(i,it)=(wmol(i,it/2)+wmol(i,(it+1)/2+1))/2.
      enddo
      enddo

      OPEN(40,file="new",STATUS='NEW',FORM='FORMATTED')
      do it=1,ntime2
         WRITE(40,400)time2(it),(ygecko2(i,it),i=1,nspec)
400      format(20E13.5)
      enddo  

      OPEN(50,file="aer.precursor.new",STATUS='NEW',FORM='FORMATTED')
      do it=1,ntime2
         WRITE(50,500)time2(it),precursor(it)
500      format(20E13.5)
      enddo

     OPEN(60,file="aer.wmol_vbs.6.new",STATUS='NEW',FORM='FORMATTED')
      do it=1,ntime2
         WRITE(60,400)time2(it),(wmol2(i,it),i=1,nspec)
      enddo


1200   CONTINUE
      END

